#!/usr/bin/perl -w
# $Id: prepexchange.pl,v 1.2 2005/10/09 22:17:24 oliver Exp $
# see http://indigo1.biop.ox.ac.uk/wiki/index.php/Exchanging_water_with_an_ion

use strict;

my $usage = "$0 z_bot z_top delta water.conf\n";

#----- input ---------
my ($ZBOT, $ZTOP, $Delta, $wlist) = @ARGV; 

my $tol = 0.01; # how far away may a water be from the desired position ?

my $L = $ZTOP - $ZBOT;
my $N = $L/(2*$Delta);


my ($i,$z, @zpos);



unless (@ARGV == 4)  { print $usage; exit 1; }

print STDERR "# L=$L DELTA=$Delta ==> N=$N\n"; 
print STDERR "# List of target positions:\n";
for($i=0;$i<$N;$i++) {
    $z = $ZBOT +($i+0.5)*2*$Delta; 
    push @zpos, $z;
    printf STDERR "%.3f ",$z;
}; 
print STDERR "\n";

print STDERR "# Finding waters within tol = $tol nm of the target positions:\n";
my ($filename, $species, $atomid, @x);
open (WLIST,"< $wlist") or die "Cannot open list of frames with water molecules '$wlist',";
WATER: while (<WLIST>) {
    chomp;
    next if (/^\s*[;\#@]/);		   
    ($filename, $species, $atomid, @x) = split;
    #print STDERR "$filename, $species, $atomid, @x\n";
    foreach $z (@zpos) {
	#print STDERR "current z=$x[2]   trying match to z=$z\n";
	if ($x[2] >= $z-$tol && $x[2] <= $z+$tol) {
	    print STDERR "match: ". ($z-$tol) ." <= $z <= ". ($z+$tol) ." (file=$filename atomid=$atomid)\n";
	    print $_ . "\n";	    
	    next WATER;   # take the first hit
	}
    }
}
		       
close(WLIST);
exit 0;
